/***************************************
 FCG Mapper16
***************************************/
function cpu_dump(d, prg_size, banksize)
{
	cpu_write(d, 0xa001, 0); //disable W-RAM
	for(local i = 0; i < (prg_size/0x4000) - 1; i += 1){
		cpu_write(d, 0x8008, i);
		cpu_read(d, 0x8000, 0x2000 * 2);
	}
	cpu_read(d, 0xc000, 0x2000 * 2);
}
function ppu_dump(d, chr_size, banksize)
{
	for(local i = 0; i < chr_size/0x400; i+=8){
		cpu_write(d, 0x8000, (i)|0,0x8001, (i)|1 );
		cpu_write(d, 0x8002, (i)|2,0x8003, (i)|3 );
		cpu_write(d, 0x8004, (i)|4,0x8005, (i)|5 );
		cpu_write(d, 0x8006, (i)|6,0x8007, (i)|7 );

		ppu_read(d, 0x0000, 0x400 * 8);
	}
}